/*
Code by Maarten Wijntjes, 2013
*/

String name="ios7";
String observer="klaas";

PImage testimage;
int dotsize=25,maxLocations=100,locationNumber=1,rectwidth=30,rectheight=30,stpsize=5,nLines;
int status=1;//1: target is shown, 2: search process

int pos[][],finalpos[][];

String[] lines;
int[][] rectdat;
int trial=0;
int minDist=20;
int startTime,endTime;
int data[][];
int randomLocations[][];
Integer[] randomArray;
int continueWithTiming=0;

/*NOTES
1) Randomize target presentation locations
2) Randomize trial order
3) Possibility to go back to status=1 in case you forgot the target
*/
void setup() {
  
  testimage=loadImage(name+"/image.png");
  size(testimage.width,testimage.height);
  noCursor();
  lines=loadStrings(name+"/data.dat");
  nLines = lines.length;
  rectdat = new int[4][lines.length];
  for (int i = 0; i < lines.length; i++) {
      String[] pieces = split(lines[i], '\t');
      rectdat[0][i]=int(pieces[0]);
      rectdat[1][i]=int(pieces[1]);
      rectdat[2][i]=int(pieces[2]);
      rectdat[3][i]=int(pieces[3]);
    }
  data = new int[4][nLines];
  //make random start positions
  randomLocations = new int[2][nLines];
  for (int i = 0; i < lines.length; i++) {
    randomLocations[0][i]=int(round(random(rectdat[2][i],width-rectdat[2][i])));
    randomLocations[1][i]=int(round(random(rectdat[3][i],height-rectdat[3][i])));
  }
  randomArray= new Integer[nLines];
  for (int j = 0; j < randomArray.length; j++) randomArray[j] = new Integer(j);
  java.util.Collections.shuffle(java.util.Arrays.asList(randomArray));
  
}


void draw() {
  //frame.setTitle("time " + round(millis()-startTime)+"distance = "+int(round(dist(trial))));
  
  if (status==1){
    noStroke();
    fill(0);
    rect(0,0,testimage.width,testimage.height);
    showCopy(randomArray[trial]);
  }
  
  if (status==2){
    image(testimage,0,0);
    ellipseMode(RADIUS);
    noFill();  // Set fill to gray
    strokeWeight(3);
    stroke(255,0,0);
    ellipse(mouseX,mouseY,10,10);
  }
  

  
}

void mouseClicked(){
  if (dist(randomArray[trial])<minDist){
    int randomtrial=randomArray[trial];
    endTime=millis()-startTime;
    data[0][randomtrial]=randomtrial+1;
    data[1][randomtrial]=rectdat[0][randomtrial];
    data[2][randomtrial]=rectdat[1][randomtrial];
    data[3][randomtrial]=endTime;
    trial=trial+1;
    
    if (trial>nLines-1){
      String[] outlines = new String[nLines];
          for (int i = 0; i < nLines; i = i+1) {
             outlines[i] = data[0][i] + "\t" +data[1][i]+ "\t" +data[2][i]+ "\t" +data[3][i];
           }
           saveStrings(name+"/"+observer+"search.dat", outlines);
          exit();
      }
    status=1;
    continueWithTiming=0;
  }
  
}

void keyPressed(){
 if (key=='b'){
  status=1;
  continueWithTiming=1;
 } 
}

void keyReleased(){
  if (status==1){
    status=2;
    if (continueWithTiming==0){
    startTime=millis();
    }
  }
  //if (status==3){status=1;}
  
  
}

float dist(int k){
  float dx=(mouseX-rectdat[0][k]);
  float dy=(mouseY-rectdat[1][k]);
  return sqrt(sq(dx)+sq(dy));
}

void showCopy(int k){
  int x=rectdat[0][k];
  int y=rectdat[1][k];
  int sw=rectdat[2][k];
  int sh=rectdat[3][k];
  int sx=round(x-sw/2);
  int sy=round(y-sh/2);
  int tx=round(testimage.width/2-sw/2);
  int ty=round(testimage.height/2-sh/2);
  tx=randomLocations[0][k];
  ty=randomLocations[1][k];
  copy(testimage, sx, sy, sw, sh, tx,ty, sw, sh);
  
  
  
}


